Index: dll/shellext/shellbtrfs/propsheet.h
===================================================================
--- dll/shellext/shellbtrfs/propsheet.h	(révision 75772)
+++ dll/shellext/shellbtrfs/propsheet.h	(copie de travail)
@@ -1,26 +1,27 @@
-/* Copyright (c) Mark Harmstone 2016
- * 
+/* Copyright (c) Mark Harmstone 2016-17
+ *
  * This file is part of WinBtrfs.
- * 
+ *
  * WinBtrfs is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Lesser General Public Licence as published by
  * the Free Software Foundation, either version 3 of the Licence, or
  * (at your option) any later version.
- * 
+ *
  * WinBtrfs is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU Lesser General Public Licence for more details.
- * 
+ *
  * You should have received a copy of the GNU Lesser General Public Licence
  * along with WinBtrfs.  If not, see <http://www.gnu.org/licenses/>. */
 
 #include <shlobj.h>
 #include <deque>
+#include <string>
 #ifndef __REACTOS__
 #include "../btrfsioctl.h"
 #else
-#include "../../drivers/filesystems/btrfs/btrfsioctl.h"
+#include "btrfsioctl.h"
 #endif
 
 #ifndef S_IRUSR
@@ -59,6 +60,18 @@
 #define S_IXOTH (S_IXGRP >> 3)
 #endif
 
+#ifndef S_ISUID
+#define S_ISUID 0004000
+#endif
+
+#ifndef S_ISGID
+#define S_ISGID 0002000
+#endif
+
+#ifndef S_ISVTX
+#define S_ISVTX 0001000
+#endif
+
 #define BTRFS_INODE_NODATASUM   0x001
 #define BTRFS_INODE_NODATACOW   0x002
 #define BTRFS_INODE_READONLY    0x004
@@ -85,15 +98,19 @@
         perms_changed = FALSE;
         uid_changed = FALSE;
         gid_changed = FALSE;
+        compress_type_changed = FALSE;
+        ro_changed = FALSE;
         can_change_perms = FALSE;
-        can_change_owner = FALSE;
+        show_admin_button = FALSE;
         thread = NULL;
         mode = mode_set = 0;
         flags = flags_set = 0;
-        
+        has_subvols = FALSE;
+        filename = L"";
+
         sizes[0] = sizes[1] = sizes[2] = sizes[3] = 0;
         totalsize = 0;
-        
+
         InterlockedIncrement(&objs_loaded);
     }
 
@@ -102,14 +119,14 @@
             GlobalUnlock(stgm.hGlobal);
             ReleaseStgMedium(&stgm);
         }
-        
+
         InterlockedDecrement(&objs_loaded);
     }
 
     // IUnknown
-    
+
     HRESULT __stdcall QueryInterface(REFIID riid, void **ppObj);
-    
+
     ULONG __stdcall AddRef() {
         return InterlockedIncrement(&refcount);
     }
@@ -116,22 +133,23 @@
 
     ULONG __stdcall Release() {
         LONG rc = InterlockedDecrement(&refcount);
-        
+
         if (rc == 0)
             delete this;
-        
+
         return rc;
     }
-    
+
     // IShellExtInit
-    
+
     virtual HRESULT __stdcall Initialize(PCIDLIST_ABSOLUTE pidlFolder, IDataObject* pdtobj, HKEY hkeyProgID);
-    
+
     // IShellPropSheetExt
-    
+
     virtual HRESULT __stdcall AddPages(LPFNADDPROPSHEETPAGE pfnAddPage, LPARAM lParam);
     virtual HRESULT __stdcall ReplacePage(UINT uPageID, LPFNADDPROPSHEETPAGE pfnReplacePage, LPARAM lParam);
-    
+
+    void init_propsheet(HWND hwndDlg);
     void change_inode_flag(HWND hDlg, UINT64 flag, UINT state);
     void change_perm_flag(HWND hDlg, ULONG perm, UINT state);
     void change_uid(HWND hDlg, UINT32 uid);
@@ -142,10 +160,11 @@
     DWORD search_list_thread();
     void do_search(WCHAR* fn);
     void update_size_details_dialog(HWND hDlg);
- 
+    void open_as_admin(HWND hwndDlg);
+    void set_cmdline(std::wstring cmdline);
+
     BOOL readonly;
     BOOL can_change_perms;
-    BOOL can_change_owner;
     BOOL can_change_nocow;
     WCHAR size_format[255];
     HANDLE thread;
@@ -152,10 +171,11 @@
     UINT32 min_mode, max_mode, mode, mode_set;
     UINT64 min_flags, max_flags, flags, flags_set;
     UINT64 subvol, inode, rdev;
-    UINT8 type;
+    UINT8 type, min_compression_type, max_compression_type, compress_type;
     UINT32 uid, gid;
-    BOOL various_subvols, various_inodes, various_types, various_uids, various_gids;
-    
+    BOOL various_subvols, various_inodes, various_types, various_uids, various_gids, compress_type_changed, has_subvols,
+         ro_subvol, various_ro, ro_changed, show_admin_button;
+
 private:
     LONG refcount;
     BOOL ignore;
@@ -164,4 +184,9 @@
     BOOL flags_changed, perms_changed, uid_changed, gid_changed;
     UINT64 sizes[4], totalsize;
     std::deque<WCHAR*> search_list;
+    std::wstring filename;
+
+    void apply_changes_file(HWND hDlg, std::wstring fn);
+    HRESULT check_file(std::wstring fn, UINT i, UINT num_files, UINT* sv);
+    HRESULT load_file_list();
 };
Index: dll/shellext/shellbtrfs/reactos.cpp
===================================================================
--- dll/shellext/shellbtrfs/reactos.cpp	(nonexistent)
+++ dll/shellext/shellbtrfs/reactos.cpp	(copie de travail)
@@ -0,0 +1,207 @@
+#include "shellext.h"
+#include <initguid.h>
+#include <ntddstor.h>
+#include <ndk/rtlfuncs.h>
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+/* So that we can link */
+DEFINE_GUID(CLSID_WICImagingFactory, 0xcacaf262,0x9370,0x4615,0xa1,0x3b,0x9f,0x55,0x39,0xda,0x4c,0x0a);
+
+/* Copied from ntoskrnl_vista */
+NTSTATUS WINAPI RtlUTF8ToUnicodeN(PWSTR uni_dest, ULONG uni_bytes_max,
+                                  PULONG uni_bytes_written,
+                                  PCCH utf8_src, ULONG utf8_bytes)
+{
+    NTSTATUS status;
+    ULONG i, j;
+    ULONG written;
+    ULONG ch;
+    ULONG utf8_trail_bytes;
+    WCHAR utf16_ch[3];
+    ULONG utf16_ch_len;
+
+    if (!utf8_src)
+        return STATUS_INVALID_PARAMETER_4;
+    if (!uni_bytes_written)
+        return STATUS_INVALID_PARAMETER;
+
+    written = 0;
+    status = STATUS_SUCCESS;
+
+    for (i = 0; i < utf8_bytes; i++)
+    {
+        /* read UTF-8 lead byte */
+        ch = (BYTE)utf8_src[i];
+        utf8_trail_bytes = 0;
+        if (ch >= 0xf5)
+        {
+            ch = 0xfffd;
+            status = STATUS_SOME_NOT_MAPPED;
+        }
+        else if (ch >= 0xf0)
+        {
+            ch &= 0x07;
+            utf8_trail_bytes = 3;
+        }
+        else if (ch >= 0xe0)
+        {
+            ch &= 0x0f;
+            utf8_trail_bytes = 2;
+        }
+        else if (ch >= 0xc2)
+        {
+            ch &= 0x1f;
+            utf8_trail_bytes = 1;
+        }
+        else if (ch >= 0x80)
+        {
+            /* overlong or trail byte */
+            ch = 0xfffd;
+            status = STATUS_SOME_NOT_MAPPED;
+        }
+
+        /* read UTF-8 trail bytes */
+        if (i + utf8_trail_bytes < utf8_bytes)
+        {
+            for (j = 0; j < utf8_trail_bytes; j++)
+            {
+                if ((utf8_src[i + 1] & 0xc0) == 0x80)
+                {
+                    ch <<= 6;
+                    ch |= utf8_src[i + 1] & 0x3f;
+                    i++;
+                }
+                else
+                {
+                    ch = 0xfffd;
+                    utf8_trail_bytes = 0;
+                    status = STATUS_SOME_NOT_MAPPED;
+                    break;
+                }
+            }
+        }
+        else
+        {
+            ch = 0xfffd;
+            utf8_trail_bytes = 0;
+            status = STATUS_SOME_NOT_MAPPED;
+            i = utf8_bytes;
+        }
+
+        /* encode ch as UTF-16 */
+        if ((ch > 0x10ffff) ||
+            (ch >= 0xd800 && ch <= 0xdfff) ||
+            (utf8_trail_bytes == 2 && ch < 0x00800) ||
+            (utf8_trail_bytes == 3 && ch < 0x10000))
+        {
+            /* invalid codepoint or overlong encoding */
+            utf16_ch[0] = 0xfffd;
+            utf16_ch[1] = 0xfffd;
+            utf16_ch[2] = 0xfffd;
+            utf16_ch_len = utf8_trail_bytes;
+            status = STATUS_SOME_NOT_MAPPED;
+        }
+        else if (ch >= 0x10000)
+        {
+            /* surrogate pair */
+            ch -= 0x010000;
+            utf16_ch[0] = 0xd800 + (ch >> 10 & 0x3ff);
+            utf16_ch[1] = 0xdc00 + (ch >>  0 & 0x3ff);
+            utf16_ch_len = 2;
+        }
+        else
+        {
+            /* single unit */
+            utf16_ch[0] = ch;
+            utf16_ch_len = 1;
+        }
+
+        if (!uni_dest)
+        {
+            written += utf16_ch_len;
+            continue;
+        }
+
+        for (j = 0; j < utf16_ch_len; j++)
+        {
+            if (uni_bytes_max >= sizeof(WCHAR))
+            {
+                *uni_dest++ = utf16_ch[j];
+                uni_bytes_max -= sizeof(WCHAR);
+                written++;
+            }
+            else
+            {
+                uni_bytes_max = 0;
+                status = STATUS_BUFFER_TOO_SMALL;
+            }
+        }
+    }
+
+    *uni_bytes_written = written * sizeof(WCHAR);
+    return status;
+}
+
+/* Quick and dirty table for conversion */
+FILE_INFORMATION_CLASS ConvertToFileInfo[MaximumFileInfoByHandlesClass] =
+{
+    FileBasicInformation, FileStandardInformation, FileNameInformation, FileRenameInformation,
+    FileDispositionInformation, FileAllocationInformation, FileEndOfFileInformation, FileStreamInformation,
+    FileCompressionInformation, FileAttributeTagInformation, FileIdBothDirectoryInformation, (FILE_INFORMATION_CLASS)-1,
+    FileIoPriorityHintInformation, FileRemoteProtocolInformation
+};
+
+/* Taken from kernel32 */
+DWORD
+BaseSetLastNTError(IN NTSTATUS Status)
+{
+    DWORD dwErrCode;
+    dwErrCode = RtlNtStatusToDosError(Status);
+    SetLastError(dwErrCode);
+    return dwErrCode;
+}
+
+/* Quick implementation, still going farther than Wine implementation */
+BOOL
+WINAPI
+SetFileInformationByHandle(HANDLE hFile,
+                           FILE_INFO_BY_HANDLE_CLASS FileInformationClass,
+                           LPVOID lpFileInformation,
+                           DWORD dwBufferSize)
+{
+    NTSTATUS Status;
+    IO_STATUS_BLOCK IoStatusBlock;
+    FILE_INFORMATION_CLASS FileInfoClass;
+
+    FileInfoClass = (FILE_INFORMATION_CLASS)-1;
+
+    /* Attempt to convert the class */
+    if (FileInformationClass < MaximumFileInfoByHandlesClass)
+    {
+        FileInfoClass = ConvertToFileInfo[FileInformationClass];
+    }
+
+    /* If wrong, bail out */
+    if (FileInfoClass == -1)
+    {
+        SetLastError(ERROR_INVALID_PARAMETER);
+        return FALSE;
+    }
+
+    /* And set the information */
+    Status = NtSetInformationFile(hFile, &IoStatusBlock, lpFileInformation,
+                                  dwBufferSize, FileInfoClass);
+
+    if (!NT_SUCCESS(Status))
+    {
+        BaseSetLastNTError(Status);
+        return FALSE;
+    }
+
+    return TRUE;
+}
+#ifdef __cplusplus
+}
+#endif

Modification de propriétés sur dll/shellext/shellbtrfs/reactos.cpp
___________________________________________________________________
Added: svn:eol-style
## -0,0 +1 ##
+native
\ No newline at end of property
